# Copyright (c) 2012 Cloudera, Inc. All rights reserved.
from com.cloudera.server.web.cmf.logs import ServerLogSearcher
# Building object that subclasses a Java interface

import log_search as ls

SERVER_LOG_TYPE = "SCMSERVER"

# This class is used to bridge the java class and the log_search module.
class ServerLogSearcher(ServerLogSearcher):

  def __init__(self, logpath, role_id, host, port):
    self.logpath = logpath
    self.role_id = role_id
    self.host = host
    self.port = port

  def searchServerLog(self,
                      start_time,
                      end_time,
                      log_level,
                      query,
                      result_limit):

    return ls.search_logs(start_time=start_time,
                          end_time=end_time,
                          log_types=[SERVER_LOG_TYPE],
                          log_paths=[self.logpath],
                          role_ids=[self.role_id],
                          log_level=log_level,
                          query=query,
                          host=self.host,
                          port=self.port,
                          role_result_limit=result_limit)["data"]


  def getServerLog(self,
                   offset,
                   direction,
                   num_events):

    return ls.log_with_context(self.logpath,
                               offset,
                               None,
                               direction,
                               num_events,
                               SERVER_LOG_TYPE,
                               self.host,
                               self.port)["data"]


