-- Copyright (c) 2012 Cloudera, Inc. All rights reserved.
--
-- Version 04522 of the CMF schema. Migration code to be applied on top of the
-- previous version.
--

update SCHEMA_VERSION set VERSION=04522;

-- Delete any existing global settings.
delete from USER_SETTINGS
  where USER_ID is null;

-- Remove nullability from user settings.
alter table USER_SETTINGS
  modify column USER_ID bigint not null;

-- New table for global settings.
create table GLOBAL_SETTINGS (
  GLOBAL_SETTING_ID bigint not null,
  OPTIMISTIC_LOCK_VERSION bigint default 0 not null,
  ATTR varchar(255) not null,
  VALUE longtext not null,
  primary key (GLOBAL_SETTING_ID)
) engine=InnoDB;

-- Attribute must be unique.
create unique index IDX_UNIQUE_GLOBAL_SETTING on GLOBAL_SETTINGS
  (ATTR);
