-- Copyright (c) 2011-2012 Cloudera, Inc. All rights reserved.
--
-- Version 3 of the CMON schema. 
--

UPDATE CMON_SCHEMA_VERSION SET VERSION=3;

CREATE TABLE `CMON_ACTIVITY` (
  `ID` bigint(20) NOT NULL,
  `SERVICE_NAME` varchar(255) DEFAULT NULL,
  `NAME` varchar(255) DEFAULT NULL,
  `BEGIN_TS` bigint(20) DEFAULT NULL,
  `END_TS` bigint(20) DEFAULT NULL,
  `ACTIVITY_TYPE` int(11) DEFAULT NULL,
  PRIMARY KEY (`ID`),
  KEY `IDX_ACTIVITY_BY_NAME` (`NAME`),
  KEY `IDX_ATTEMPT_SERIES_BY_NAME` (`SERVICE_NAME`)
) ENGINE=InnoDB;

CREATE TABLE `CMON_ACTIVITY_ATTRIBUTE` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `ACTIVITY_ID` bigint(20) NOT NULL,
  `METRIC_ID` int(11) NOT NULL,
  `STRING_ATTR` varchar(255) NOT NULL,
  PRIMARY KEY (`ID`),
  KEY `IDX_BY_ACTIVITY_ID` (`ACTIVITY_ID`),
  CONSTRAINT `FK_ACTIVITY_ATTR_ACTIVITY` FOREIGN KEY (`ACTIVITY_ID`) REFERENCES `CMON_ACTIVITY` (`ID`) ON DELETE CASCADE
) ENGINE=InnoDB;

CREATE TABLE `CMON_ACTIVITY_LAST_METRIC_VALUE` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `ACTIVITY_ID` bigint(20) NOT NULL,
  `METRIC_ID` int(11) NOT NULL,
  `TS` bigint(20) NOT NULL,
  `VALUE` double NOT NULL,
  PRIMARY KEY (`ID`),
  KEY `IDX_BY_ACTIVITY_ID` (`ACTIVITY_ID`),
  CONSTRAINT `FK_ACTIVITY_LMV_ACTIVITY` FOREIGN KEY (`ACTIVITY_ID`) REFERENCES `CMON_ACTIVITY` (`ID`) ON DELETE CASCADE
) ENGINE=InnoDB;

CREATE TABLE `CMON_ATTEMPT` (
  `ID` bigint(20) NOT NULL,
  `NAME` varchar(255) NOT NULL,
  `BEGIN_TS` bigint(20) DEFAULT NULL,
  `END_TS` bigint(20) DEFAULT NULL,
  `HOST` varchar(255) DEFAULT NULL,
  `ATTEMPT_TYPE` int(11) NOT NULL,
  `ACTIVITY_ID` bigint(20) NOT NULL,
  PRIMARY KEY (`ID`),
  KEY `FK_ATTEMPT_ACTIVITY` (`ACTIVITY_ID`),
  KEY `IDX_ATTEMPT_ACTIVITY` (`ACTIVITY_ID`),
  KEY `IDX_ATTEMPT_BY_NAME` (`name`),
  CONSTRAINT `FK_ATTEMPT_ACTIVITY` FOREIGN KEY (`ACTIVITY_ID`) REFERENCES `CMON_ACTIVITY` (`ID`) ON DELETE CASCADE
) ENGINE=InnoDB;

CREATE TABLE `CMON_ATTEMPT_LAST_METRIC_VALUE` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `ATTEMPT_ID` bigint(20) NOT NULL,
  `METRIC_ID` int(11) NOT NULL,
  `TS` bigint(20) NOT NULL,
  `VALUE` double NOT NULL,
  PRIMARY KEY (`ID`),
  KEY `IDX_BY_ATTEMPT_ID` (`ATTEMPT_ID`),
  CONSTRAINT `FK_ATTEMPT_LMV_ATTEMPT` FOREIGN KEY (`ATTEMPT_ID`) REFERENCES `CMON_ATTEMPT` (`ID`) ON DELETE CASCADE
) ENGINE=InnoDB;
